<template>
  <div>
    <div class="flex flex-no-wrap bg-gray-200 text-white h-screen">
      <div class="container mx-auto py-10 h-auto md:w-4/5 w-11/12 px-6">
        <router-link to="/dashboard/add-game">
          <span
            class="mb-2 text-white bg-indigo-700 hover:bg-indigo-800 focus:ring-4 focus:ring-indigo-300 font-medium rounded-lg text-sm px-3 py-2 text-center inline-flex items-center  dark:bg-indigo-600 dark:hover:bg-indigo-700 dark:focus:ring-indigo-800"
          >
            New game
          </span>
        </router-link>

        <div class="flex flex-col">
          <div class="-my-2 overflow-x-auto sm:-mx-6 lg:-mx-8">
            <div
              class="py-2 align-middle inline-block min-w-full sm:px-6 lg:px-8"
            >
              <div
                class="shadow overflow-hidden border-b border-gray-200 sm:rounded-lg"
              >
                <table class="min-w-full divide-y divide-gray-200">
                  <thead class="bg-gray-50">
                    <tr>
                      <th
                        scope="col"
                        class="px-6 py-3 text-left text-xs font-medium text-gray-500 uppercase tracking-wider"
                      >
                        Jeu
                      </th>
                      <th
                        scope="col"
                        class="relative px-6 py-3 text-xs font-medium text-gray-500 uppercase"
                      >
                        <span>Actions</span>
                      </th>
                    </tr>
                  </thead>
                  <tbody class="bg-white divide-y divide-gray-200">
                    <tr v-for="(game, key) in games" :key="`${key}`">
                      <td class="px-6 py-4 whitespace-nowrap">
                        <div class="text-sm text-gray-900">{{ game.name }}</div>
                      </td>
                      <td
                        class="px-6 py-4 whitespace-nowrap text-center text-sm font-medium"
                      >
                        <div class="flex gap-4 justify-center">
                          <router-link :to="`/dashboard/edit-game/${game.id}`">
                            <span
                              class="text-indigo-600 hover:text-indigo-900 cursor-pointer"
                            >
                              Editer
                            </span>
                          </router-link>
                          <a
                            @click="deleteGame(game.id, key)"
                            class="text-indigo-600 hover:text-indigo-900 cursor-pointer"
                            >Remove</a
                          >
                        </div>
                      </td>
                    </tr>
                  </tbody>
                </table>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
export default {
  name: "Game",
  data() {
    return {
      games: [],
      urlGetStudio: `https://${window.location.hostname}:8443/studios/`,
      urlGames: `https://${window.location.hostname}:8443/games/`
    }
  },
  inject: ["createAlert", "user"],
  methods: {
    deleteGame: function(id, key) {
      fetch(this.urlGames + id, {
        headers: {
          Accept: "application/json",
          "Content-Type": "application/json",
          Authorization: "Bearer " + this.user.token
        },
        method: "DELETE"
      })
        .then((res) => {
          if (res.ok) {
            this.games.splice(key, 1)
          } else {
            throw new Error("Something went wrong")
          }
        })
        .then((data) => {})
        .catch(() => {
          this.createAlert({
            color: "red",
            text: "Une erreur est survenue",
            icon: "times"
          })
        })
    }
  },
  beforeMount() {
    fetch(this.urlGetStudio + this.user.studio, {
      headers: {
        Accept: "application/json",
        "Content-Type": "application/json"
      },
      method: "GET"
    })
      .then((res) => {
        if (res.ok) {
          return res.json()
        } else {
          throw new Error("Something went wrong")
        }
      })
      .then((data) => {
        if (data) {
          this.games = data.games
        } else {
          this.createAlert({
            color: "red",
            text: "Une erreur est survenue",
            icon: "times"
          })
        }
      })
      .catch(() => {
        this.createAlert({
          color: "red",
          text: "Une erreur est survenue",
          icon: "times"
        })
      })
  }
}
</script>

<style scoped>
.is-visible {
  display: block;
}
</style>
